#include "stdafx.h"
#include "PluginMenuItem.h"

#include <msclr/marshal.h>
using namespace msclr::interop;

void __stdcall PWCMenuProc(TPWPInstance* instance, const char* item);
extern TPWPFunctions g_pwpfunc_t;

using namespace PWSPlugin;

PluginMenuItem::PluginMenuItem(String^ item, Proc^ proc)
{
	this->item = item;
	this->proc = proc;
}

void PluginMenuItem::UpdateInstance(TPWPInstance* instance)
{
	this->instance = instance;
}

bool PluginMenuItem::SetState(bool check)
{
	marshal_context ctx;
	if (1 != g_pwpfunc_t.PWPMenuItem_SetState(this->instance, ctx.marshal_as<const char*>(this->item), check))
	{
		return false;
	}

	return true;
}

int PluginMenuItem::GetState()
{
	marshal_context ctx;
	return g_pwpfunc_t.PWPMenuItem_GetState(this->instance, ctx.marshal_as<const char*>(this->item));
}

String^ PluginMenuItem::GetSelect()
{
	marshal_context ctx;
	const char* sel = g_pwpfunc_t.PWPMenuItem_GetSelect(this->instance, ctx.marshal_as<const char*>(this->item));
	if (NULL == sel)
	{
		return nullptr;
	}

	return marshal_as<String^>(sel);
}

bool PluginMenuItem::SetEnable(bool enable)
{
	marshal_context ctx;
	if (1 != g_pwpfunc_t.PWPMenuItem_SetEnable(this->instance, ctx.marshal_as<const char*>(this->item), enable))
	{
		return false;
	}

	return true;
}

int PluginMenuItem::GetEnable()
{
	marshal_context ctx;
	return g_pwpfunc_t.PWPMenuItem_GetEnable(this->instance, ctx.marshal_as<const char*>(this->item));
}

bool PluginMenuItem::SetVisible(bool visible)
{
	marshal_context ctx;
	if (1 != g_pwpfunc_t.PWPMenuItem_SetVisible(this->instance, ctx.marshal_as<const char*>(this->item), visible))
	{
		return false;
	}

	return true;
}

int PluginMenuItem::GetVisible()
{
	marshal_context ctx;
	return g_pwpfunc_t.PWPMenuItem_GetVisible(this->instance, ctx.marshal_as<const char*>(this->item));
}

void PluginMenuItem::Call()
{
	this->proc(this->item);
}